<template>
  <div id="app">
    <div v-if="!loading" class="grid cube">
      <div class="shadow hide" @click="toggleShadow()"></div>
      <div class="grid parent" :id="`data-${n-1}`" @click="zoomGrid(n-1)" v-for="n in 9" :key="n">
        <template v-if="n % 2 !== 0">
          <div class="child" v-for="x in 9" :key="x">
            <template v-if="n > 0 && map[n-1] && map[n-1].includes(x-1)">
              <div class="data">
                <div class="number">{{ items[x-1] ? items[x-1].nomor : 'No title' }}</div>
                <div class="letter">{{ items[x-1] ? items[x-1].title : 'No Number' }}</div>
              </div>
            </template>
            <template v-else>
              <div class="empty">
                <div class="number"></div>
                <div class="letter"></div>
              </div>
            </template>
          </div>
        </template>
        <template v-if="n % 2 == 0">
          <div></div>
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'App',
  data() {
    return {
      map: [
        [0,1,2,6,7,8],
        [],
        [1,3,4,5,7],
        [],
        [0,1,2,3,5,6,7,8],
        [],
        [3,4,5],
        [],
        [0,2,6,8]
      ],
      loading: true,
      items: null,
    }
  },
  mounted() {
    axios.get('https://staging.ina17.com/dev_test/encryptionData.json')
      .then(response => {
        this.items = JSON.parse(atob(response.data.data));
        this.loading = false;
      }).catch(error => {
        console.error(error);
      });
  },
  methods: {
    zoomData(row) {
      setTimeout(() => {
        const dataElement = document.getElementById(`data-${row}`);
        if (dataElement) {
          dataElement.classList.toggle('zoom');
        }
      }, 0);  
    },
    zoomGrid(row) {
      const shadowElement = document.querySelector(".shadow");
      const gridCopy = this.$el.querySelector(`.grid.parent[id="data-${row}"]`).cloneNode(true);

      this.toggleShadow();

      gridCopy.classList.add('zoom');

      shadowElement.innerHTML = "";
      shadowElement.appendChild(gridCopy);

      gridCopy.style.top = '50%';
      gridCopy.style.left = '50%';
      gridCopy.style.transform = 'translate(-50%, -50%) scale(1.2)';

      gridCopy.addEventListener('click', () => {
        gridCopy.remove();
      });
    },
    toggleShadow() {
      const shadowElement = document.querySelector(".shadow");
      shadowElement.classList.toggle("hide");
    },
    getContent(row, col, type) {
      if (type === 'number') {
        return row * 3 + col - 3;
      } else if (type === 'letter') {
        return String.fromCharCode(64 + row * 3 + col);
      }
    }
  }
}
</script>

<style scoped>
* {
  box-sizing: border-box;
}


.grid {
  width: 450px;
  margin: 0 auto;
  display: grid;
  grid-template-columns: repeat(3, 1fr);
}

.grid.parent {
  width: 100%;
}

.shadow .grid.parent {
  width: 150px;
}

.child {
  background-color: cyan;
}

.child > .data,
.child > .empty {
  padding: 5px;
  height: 50px;
}

.child > .data {
  position: relative;
  transition: transform 0.3s ease-in-out;
  background-color: lime;
}

.child > .data > div {
  width: 100%;
  text-align: center;
}

.child > .data > .number {
  font-size: 14px;
  border: 0.1px solid #eee;
}

.grid.parent.zoom {
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%) scale(1.2); /* Center and zoom */
  z-index: 10;
}

.shadow {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  z-index: 10;
  background-color: rgba(0,0,0,0.5);
}

.shadow.hide {
  display: none;
}

</style>
